--[[
    Created by Pricklygoat723
	1:22 PM Sunday, December 10, 2023
	
	Lists all the hunter achievement mobs currently up in your current zone.
	Clears all /maploc then marks all the hunters on the map with a /maploc white circle and X.	
	The Hunters.lua was just parsed out from the achievements "Output To File".
--]]
---@type Mq
mq = require('mq')
require "Hunters"


function Main()
    local count = 0
	local zone_key = mq.TLO.Zone()
	if not hunters[zone_key] then
		print("Zone key not found: " .. mq.TLO.Zone())
		return
	end 
	local length = 0
	for _ in pairs(hunters[zone_key]) do
		length = length + 1
	end	
	local use_maploc = mq.TLO.Plugin('MQ2Map').IsLoaded()
	if use_maploc then
		mq.cmd('/squelch /maploc remove')
	end
	for i=1,mq.TLO.SpawnCount('npc targetable')() do
		local xSpawn = mq.TLO.NearestSpawn(i .. ', npc targetable')
		if hunters[zone_key][xSpawn.DisplayName()] then
			count = count + 1
			print(xSpawn.Name() .. ' (' .. xSpawn.Race() .. ') ' .. xSpawn.Distance3D() .. ' ' .. xSpawn.X() .. ', ' .. xSpawn.Y())
			if use_maploc then
				mq.cmdf('/squelch /maploc %s %s %s size 70 width 3 radius 100 color 255 255 255 rcolor 255 255 255', xSpawn.Y(), xSpawn.X(), xSpawn.Z())
			end
		end
	end
    print('ListHunters [' .. mq.TLO.Zone() .. ']: ' .. count .. ' of ' .. length .. ' up.')
end

Main()